Player = class("Player", Actor)

function Player:initialize(x, y, world, camera)

	self.onPlanet = false
	
	self.texture = love.graphics.newImage("res/player.png")
	self.texture:setFilter("nearest", "nearest")
	
	Actor.initialize(self, x, y, BLOCK_SIZE, BLOCK_SIZE * 2, world)
	self.fixture:setUserData({
		parent = self
		})
		
	self.type = PLAYER
	
	self.camera = camera
	
	self.previousPositionX = 0
	self.newPositionX = 0

end

function Player:update(dt)

	self:processKeys(dt)	
	
		
	Actor.update(self, dt)

end

function Player:draw()

	love.graphics.draw(
		self.texture,
		self.x,
		self.y,
		self.body:getAngle(),
		1.25,
		1.15,
		self.w / 2,
		self.h / 2
	)

	--Actor.draw(self)

end

function Player:processKeys()

	local xSpeed, ySpeed = self.body:getLinearVelocity()
	
	self.previousPositionX, self.previousPositionY = self.newPositionX, self.newPositionY
	
	self.newPositionX, self.newPositionY = love.mouse:getPosition()
	
	if love.keyboard.isDown('a') then
		local x, y = self.body:getWorldVector(-1,0)
			self.body:applyForce(5 * x, 5 * y)
	elseif love.keyboard.isDown('d') then
		local x, y = self.body:getWorldVector(1,0)
			self.body:applyForce(5 * x, 5 * y)
	end
	
	if love.keyboard.isDown('s') then

	end

	
	if love.mouse.isDown("r") == true then
		love.mouse.setVisible(false)
		local diffX = self.newPositionX - self.previousPositionX
		if love.mouse:getX() >= love.graphics.getWidth()- 5 or love.mouse:getX() <= 5  then
			self.previousPositionX = love.graphics.getWidth()/2
			self.newPositionX = love.graphics.getWidth()/2
			love.mouse.setPosition(love.graphics.getWidth()/2,love.graphics.getHeight()/2)
		end
		local angleAdd = (diffX)
		self.body:applyTorque(angleAdd)
	else
		if love.mouse.isVisible() == false then
			love.mouse.setVisible(true)
			love.mouse.setPosition(love.graphics.getWidth()/2,love.graphics.getHeight()/2)
		end
	
	end
	
end

function Player:keyPressed(key, unicode)

	if unicode == 119 then
		local x, y = self.body:getWorldVector(0,-1)
		self.body:applyLinearImpulse( x, y)
	end
	
end

function Player:mousepressed( x, y, mb )
   if mb == "wu" and SCALE < 15 then
      SCALE = SCALE + 0.3
   end

   if mb == "wd" and SCALE > 2.5 then
      SCALE = SCALE - 0.3
   end
end


function Player:beginContact(fixture, coll)

end

function Player:endContact(fixture, coll)
    
end

function Player:preSolve(fixture, coll)
    
end

function Player:postSolve(fixture, coll)
    
end